
#
# Verify the solver's type in the software tree 
#

if (-f "TYPE") {
  $type = `cat TYPE`;
  $type =~ s/\s//g;
  $type = "\L$type";
} else {
  $type = "";
} 

#
# Get current lists of types
#

chomp(@list =  `cat $ENV{SERVER_VAR}/lib/solver_tree`);
foreach (@list) {
  ($title, $path) = split(/\=/); 
  $path =~ s/\s$//;
  if ($type eq $path) {
    print "Placing into $title($path) branch of tree.\n";
    $found=1;
    last;
  }
}

unless($found) {
  if (length($type)>0) {
    print "\"$type\" is an invalid type.\n"; 
  } else {
    print "You need to specify the solver's type.\n"; 
  }
  print "Choose from the following:\n\n"; 
  foreach (@list) {
    ($title, $path) = split(/\=/); 
    $path =~ s/\s$//;
    print "$title = $path\n"; 
  }
  exit 1;
} else {
  system("echo $type > TYPE");
}
